WP-CLI
======

- [Introduction](#introduction)
- [Installation](#installation)
- [The Themosis command](#the-themosis-command)


Introduction
------------

The Themosis framework comes with a [WP-CLI](http://wp-cli.org/) configuration file which points to the folder where WordPress is installed. WP-CLI is a command line tool for handling your WordPress installation.

Installation
------------

### Install WP-CLI on UNIX like environment.

> Please first check the [WP-CLI requirements](http://wp-cli.org/#requirements) before installing it.

Execute the following statements in your `Terminal`:

```bash
curl -O https://raw.githubusercontent.com/wp-cli/builds/gh-pages/phar/wp-cli.phar
```

```bash
chmod +x wp-cli.phar
sudo mv wp-cli.phar /usr/local/bin/wp
```

This will allow you to use the `wp` command inside your Terminal.

### Install WP-CLI on Windows.

Run the following composer statement from your `Console`:

```bash
composer create-project wp-cli/wp-cli --no-dev
```

This will download and create a directory `wp-cli` on your system. We recommend to store this directory on a location like `c:\developer\tools\` to avoid mixing your development tools and personal files.

Then add the `wp-cli\bin` folder to your system variable `PATH`. For example, using the recommended installation location, you'll store the following path to your system variable `PATH`: `c:\developer\tools\wp-cli\bin;`

This will allow you to use the `wp` command inside your Console.

The Themosis command
--------------------

We have an ongoing project in order to add a `themosis` command directly into the WP_Cli. Please check this [open GitHub issue](https://github.com/themosis/framework/issues/296) if you have any suggestions or features requests regarding a Themosis CLI tool.